/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_OCOR                                                     */
/* Tabela : OCORRENCIA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_OCOR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_OCOR
GO

CREATE TRIGGER DTULTATU_OCOR
ON OCORRENCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'OCORRENCIA', null, 'CDGRPOCOR='+CDGRPOCOR+';'+'CDOCORR='+CDOCORR+';',
                CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE OCORRENCIA
      SET DTULTATUOCOR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(OCORRENCIA.CDGRPOCOR,0) = ISNULL(INSERTED.CDGRPOCOR,0)) AND
            (ISNULL(OCORRENCIA.CDOCORR,0)   = ISNULL(INSERTED.CDOCORR,0));
   END;
END;
GO

UPDATE OCORRENCIA SET DTULTATUOCOR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUOCOR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUOCOR' and
            type = 'D')
   ALTER TABLE OCORRENCIA DROP CONSTRAINT DEFAULT_DTULTATUOCOR
GO

ALTER TABLE OCORRENCIA ADD CONSTRAINT DEFAULT_DTULTATUOCOR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUOCOR
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_OCOR','4.11.194';
GO


